set terminal postscript landscape color "Helvetica" 12
set output 'tree-time.eps'
set title 'Tree benchmark [15 runs/configuration]'
set autoscale
set boxwidth 0.25
set xrange [0:4.75]
set ylabel "execution time [s] \n (lower is better)"
set xlabel 'configurations'

set style fill solid 0.5 noborder

set xtics ("n=15" 0.87, "n=16" 2.37, "n=17" 3.87)

plot 'time/persistent.dat' using 1:($2)/1000000000 with boxes lc rgb "#660000" lw 1.5 title "persistent", \
'time/gc.dat' using 1:($2)/1000000000 with boxes lc rgb "#006600" lw 1.5 title "gc", \
'time/stm-gc.dat' using 1:($2)/1000000000 with boxes lc rgb "#000066" lw 1.5 title "stm+gc", \
'time/stm-only.dat' using 1:($2)/1000000000 with boxes lc rgb "#606060" lw 1.5 title "stm only"
